---
title: DataTransfer.setDragImage()
slug: Web/API/DataTransfer/setDragImage
tags:
  - API
  - H5 DnD
  - HTML DOM
  - Method
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>When a drag occurs, a translucent image is generated from the drag target (the element the {{event("dragstart")}} event is fired at), and follows the mouse pointer during the drag. This image is created automatically, so you do not need to create it yourself. However, if a custom image is desired, the <strong><code>DataTransfer.setDragImage()</code></strong> method can be used to set the custom image to be used. The image will typically be an {{HTMLElement("image")}} element but it can also be a {{HTMLElement("canvas")}} or any other visible element.</p>

<p>The method's <code>x</code> and <code>y</code> coordinates define how the image should appear relative to the mouse pointer. These coordinates define the offset into the image where the mouse cursor should be. For instance, to display the image so that the pointer is at its center, use values that are half the width and height of the image.</p>

<p>This method must be called in the {{event("dragstart")}} event handler.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>dataTransfer</em>.setDragImage(img | element, xOffset, yOffset);
</pre>

<h3 id="Arguments">Arguments</h3>

<dl>
 <dt><em>img | </em>element</dt>
 <dd>An image {{domxref("Element")}} element to use for the drag feedback image.</dd>
 <dd>If {{domxref("Element")}} is an img element, then set the drag data store bitmap to the element's image (at its intrinsic size); otherwise, set the drag data store bitmap to an image generated from the given element (the exact mechanism for doing so is not currently specified).</dd>
 <dt><em>xOffset</em></dt>
 <dd>A <code>long</code> indicating the horizontal offset within the image.</dd>
 <dt><em>yOffset</em></dt>
 <dd>A <code>long</code> indicating the vertical offset within the image.</dd>
</dl>

<h3 id="Return_Value">Return value</h3>

<dl>
 <dt>void</dt>
 <dd></dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example shows how to use the <code>setDragImage()</code> method. Note the example refers to an image file named <code>example.gif</code>. If that file is present, it will be used as the drag image and if that file is not present, the browser will use its default drag image.</p>

<p><a href="https://codepen.io/webgeeker/full/KBzrxE/">demo</a></p>

<pre class="brush: js">&lt;!DOCTYPE html&gt;
&lt;html lang=en&gt;
&lt;title&gt;Example of DataTransfer.setDragImage()&lt;/title&gt;
&lt;meta name="viewport" content="width=device-width"&gt;
&lt;style&gt;
  div {
    margin: 0em;
    padding: 2em;
  }
  #source {
    color: blue;
    border: 1px solid black;
  }
  #target {
    border: 1px solid black;
  }
&lt;/style&gt;
&lt;script&gt;
function dragstart_handler(ev) {
 console.log("dragStart");
 // Set the drag's format and data. Use the event target's id for the data
 ev.dataTransfer.setData("text/plain", ev.target.id);
 // Create an image and use it for the drag image
 // NOTE: change "example.gif" to an existing image or the image will not
 // be created and the default drag image will be used.
 var img = new Image();
 img.src = 'example.gif';
 ev.dataTransfer.setDragImage(img, 10, 10);
}

function dragover_handler(ev) {
 console.log("dragOver");
 ev.preventDefault();
}

function drop_handler(ev) {
 console.log("Drop");
 ev.preventDefault();
 // Get the data, which is the id of the drop target
 var data = ev.dataTransfer.getData("text");
 ev.target.appendChild(document.getElementById(data));
}
&lt;/script&gt;
&lt;body&gt;
&lt;h1&gt;Example of &lt;code&gt;DataTransfer.setDragImage()&lt;/code&gt;&lt;/h1&gt;
 &lt;div&gt;
   &lt;p id="source" ondragstart="dragstart_handler(event);" draggable="true"&gt;
     Select this element, drag it to the Drop Zone and then release the selection to move the element.&lt;/p&gt;
 &lt;/div&gt;
 &lt;div id="target" ondrop="drop_handler(event);" ondragover="dragover_handler(event);"&gt;Drop Zone&lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'interaction.html#dom-datatransfer-setdragimage','setDragImage()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'editing.html#dom-datatransfer-setdragimage','setDragImage()')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Not included in W3C HTML5 {{Spec2('HTML5 W3C')}}</td>
  </tr>
  <tr>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransfer.setDragImage")}}</p>

<h2 id="See_also">See also</h2>

<p>{{page("/en-US/docs/Web/API/DataTransfer", "See also")}}</p>

<div class="jfk-bubble gtx-bubble" style="left: -1px; top: 27px; opacity: 1; transition: opacity 0.218s ease-out 0s;">
<div class="jfk-bubble-content-id" id="bubble-4">
<div id="gtx-host" style="max-width: 400px;"></div>
</div>

<div class="jfk-bubble-closebtn-id jfk-bubble-closebtn"></div>

<div class="jfk-bubble-arrow-id jfk-bubble-arrow jfk-bubble-arrowup" style="left: 15px;">
<div class="jfk-bubble-arrowimplbefore"></div>

<div class="jfk-bubble-arrowimplafter"></div>
</div>
</div>
